 // FormExample.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

// For I/O
#include <stdio.h>

// For getting compile time info about the component
#import "..\..\Component\TextPrinter.dll" no_namespace

int main(int argc, char* argv[])
{
	// Init COM
	CoInitialize(NULL);
	// Enter COM scope
	{
		try
		{
			// Create object
			IFormTextPrinterPtr printer(_uuidof(FormTextPrinter));
			// Load Form from file
			printer->FormFile="..\\n.txt";
			printer->SetField(L"Product",L"TextPrinter");
			printf("%s\n",(LPCSTR)printer->Port);
			printf("%d\n",printer->Codepage);
			printer->PrintForm();
			printer->ClearForm();
			
			// Load Form from string
			printer->Form=L"Demo of Cinema Ticket\r\n\r\nMovie: %Movie%\r\nTime: %Time%\r\nPrice: %Price%\r\n\r\n";
			printer->SetField(L"Movie",L"Using components makes you development shorter!!");
			printer->SetField(L"Price",29.95);
			for(int i=0;i<3;i++) // print 3 tickets with different time
			{
				// Generate variant time/date
				VARIANT v;
				DATE d;
				SYSTEMTIME st;
				GetSystemTime(&st);
				SystemTimeToVariantTime(&st,&d);
				VariantInit(&v);
				V_VT(&v)=VT_DATE;
				V_DATE(&v)=d;
				// Set field and print.
				// TextPrinter will render the time/date by itself.
				printer->SetField(L"Time",v);
				printer->PrintForm();
				// wait
				printf("Waiting for one second.\n");
				Sleep(1000);
				// Note, you can also render the time yourself and pass a string to TextPrinter if you wish.
			}

			// Load Form from file
			printer->FormFile="..\\u8.txt";
			printer->SetField(L"Description",L"This is a long description. It will be cut to 40 characters.");
			printer->SetField(L"Price",29.95);
			printer->PrintForm();
		}
		catch(_com_error &e)
		{
			printf("%X\n%s\nPress enter\n",e.Error(),(LPCSTR)e.Description());
			getchar();
		}
	}
	// Uninit COM and return
	CoUninitialize();
	return 0;
}
